/****************************************************************************/
/* clip.c    (c) Copyright Black Ice Software Inc.  1989 - 1991             */
/*                   All Rights Reserved                                    */
/*                   Unpublished and confidential material.                 */
/*                   --- Do not Reproduce or Disclose ---                   */
/****************************************************************************/
HBITMAP FAR PasteText( HWND hWnd )
{
    HANDLE hMemText;                   /* handle to the clipboards TEXT */
	  HDC hDC;
	  HBITMAP hBitMap;
	  HCURSOR hOldCur;

     /* ask for control of the clipboard */
     if (!OpenClipboard( hWnd ))
     {
          MessageBox( hWnd, (LPSTR)"Could not open clipboard", (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
          return( FALSE );
     }

	   // Displays an hourglass-cursor and saves the original one.
	   hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));

     hMemText = GetClipboardData( CF_TEXT );     /* take text */
     if (!hMemText)                              /* did we get it? */
     {
		   CloseClipboard( );
        MessageBox( hWnd, (LPSTR)"Could not receive bitmap from clipboard", (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
        return( NULL );
     }
		hDC=GetDC(hWnd=GetActiveWindow());
     hBitMap = LoadASCIIIntoBitmap( hWnd, hMemText);
		ReleaseDC(hWnd, hDC);
		// Closes the clipboard
		CloseClipboard();
		// Restores original cursor from hourglass-cursor.
		SetCursor(hOldCur);
		return( hBitMap );

}

//----------------------------------------------------------------------------
			case ASCII_FORMAT:
				nFileHandler=OpenFile(szFileName,(LPOFSTRUCT)&ofs,OF_READ);
				if (nFileHandler==-1)
					{
						return (FALSE);
					}
				// compute memory needed
				dwSize=filelength(nFileHandler);
				// allocate memory
				hRet=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dwSize);
				if (hRet==NULL)
					{
						close(nFileHandler);
                        MessageBox( hWnd, (LPSTR)"Not enough memory !", 
						          (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
						return (FALSE);
					}

				// Displays an hourglass-cursor and saves the original one.
				hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));

				// read text into memory
				lpByte= (void FAR *)GlobalLock(hRet);
				lread(nFileHandler,lpByte,dwSize); // capable to read more than 64K!!!!
				GlobalUnlock(hRet);
				close(nFileHandler);
			
				if (lpPage->hCurrentBitmap!=NULL)
					{
						DeleteObject(lpPage->hCurrentBitmap);
						lpPage->hCurrentBitmap=NULL;
					}
				hDC=GetDC(hWnd=GetActiveWindow());
				lpPage->hCurrentBitmap = LoadASCIIIntoBitmap(hWnd,hRet);
				ReleaseDC(hWnd, hDC);
				GlobalFree(hRet);

				// Restores original cursor from hourglass-cursor.
				SetCursor(hOldCur);

				return ( (lpPage->hCurrentBitmap==NULL) ? FALSE:TRUE  );
				break;

//-------------------------------------------------------------------------

/**********************************************************************************
  Function
		LoadASCIIIntoBitmap

  Parameters
		hWnd: Handle of active window.
		hMem: Memory handle of the previously loaded text file.

  Returns
		A valid bitmap handle or NULL in case of any error.

  Description
		It loads the ASCII text located in the memory into a bitmap.

  Notes
		None.

  Author
		"Vamosi_Janos",	01/22/91		Initial version.
**********************************************************************************/

HBITMAP LoadASCIIIntoBitmap(HWND hWnd,HANDLE hMem)
{
 HPSTR hpRunner, hpszText;
 DWORD dwBlockSize;
 int nRows, nCols, nWidest;
 unsigned int i;
 TEXTMETRIC tm;
 int nWidth,nHeight;
 int nXExtent,nYExtent;
 int nCharHeight;
 HDC hDC,hdcBit;
 HBITMAP hbmTemp;
 RECT rRect;

      // Lock memory
	  hpRunner = hpszText = (HPSTR)GlobalLock(hMem);
	  if (hpszText==NULL)
		{
          MessageBox( hWnd, (LPSTR)"Could not lock the data area", (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
          return( NULL );
		}
		
	  dwBlockSize = GlobalSize(hMem);	// Determines the size of memory block.
	  hpszText[dwBlockSize-1] = 0; 		// Zeroes the last byte of block.

		// compute number of rows, widest row
		nRows=1;
		nWidest=nCols=1;
		for (i=0; *hpRunner; i++) 
			{
				switch (*(hpRunner++))
					{
						case 13: //CR
							nRows++;
							if (nCols>nWidest)
								{
									nWidest=nCols;
								}
							nCols=0;
							break;
						case 8: //TAB
							nCols+=8;
							break;
						default:
							nCols++;
							break;
					}

			}
		// if last rows doesn t contain CR
		if (nCols>nWidest)
			{
				nWidest=nCols;
			}


		// compute appropriate bitmap dimensions
		hDC=GetDC(hWnd);
	  	hdcBit=CreateCompatibleDC(hDC);
	  	if (hdcBit==NULL)
			{
				ReleaseDC(hWnd,hDC);
				GlobalUnlock(hMem);
	          	MessageBox( hWnd, (LPSTR)"Unable to create DC", (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
	          	return( NULL );
			}
     	ReleaseDC(hWnd,hDC);
		GetTextMetrics(hdcBit,(LPTEXTMETRIC)&tm);
		nXExtent = nWidth = (nWidest+5)*tm.tmAveCharWidth;
		nCharHeight = tm.tmAscent+tm.tmDescent+tm.tmExternalLeading;
		nYExtent = nHeight = (nRows+1) * nCharHeight;

		// ask API to compute surroinding rectangle
		SetRectEmpty( (LPRECT)&rRect);
		rRect.right = nXExtent;
		rRect.bottom= nYExtent;

		// It does not draw the text, only adjusts the size of the rectangle
	    DrawText(hdcBit,hpszText,-1,(LPRECT)&rRect, DT_CALCRECT|
                                            DT_EXTERNALLEADING|DT_LEFT);
		nWidth=nXExtent = rRect.right;
		nHeight=nYExtent = rRect.bottom;


		// try to create bitmap
		hbmTemp=NULL;
		do
			{
				// monochrome bitmap will do
				hbmTemp=CreateBitmap(
										nXExtent,	//width
										nYExtent,	//height
										1,				//planes
										1,				//bitcount
										(LPSTR)NULL // initialization
										);
				if (hbmTemp==NULL)
					{
						// decrement physical dimensions if bitmap would be too large
						nYExtent /=2;
					}
			}while ( (hbmTemp==NULL) && (nYExtent > nCharHeight) );

	  if (hbmTemp==NULL)
		{
		  DeleteDC(hdcBit);
		  GlobalUnlock(hMem);
          MessageBox( hWnd, (LPSTR)"Not enough memory !", (LPSTR)"ERROR", MB_ICONEXCLAMATION|MB_OK);
          return( NULL );
		}

	  // clear bitmap white
	  SelectObject(hdcBit,hbmTemp);
	  SelectObject(hdcBit,GetStockObject(WHITE_BRUSH));
	  PatBlt(hdcBit,0,0,nXExtent,nYExtent,PATCOPY);

	  // draw text into bitmap
	  SetMapMode(hdcBit,MM_ANISOTROPIC);
	  SetWindowExt(hdcBit,nWidth,nHeight);
	  SetViewportExt(hdcBit,nXExtent,nYExtent);

	  // If the height exceeds certain limlit (cc. 480)
	  // than it won't draw properly unless you use DT_NOCLIP !!??

	  DrawText(hdcBit,hpszText,-1,(LPRECT)&rRect, DT_NOCLIP|
                                          DT_EXTERNALLEADING|DT_LEFT);

	  // finish job
	  DeleteDC(hdcBit);
 	  GlobalUnlock(hMem);
	  
      return( hbmTemp );

}  
//-----------------------------------------------------------------------------
