/****************************************************************************/
/* data.h    (c) Copyright Black Ice Software Inc.  1989 - 1991             */
/*                   All Rights Reserved                                    */
/*                   Unpublished and confidential material.                 */
/*                   --- Do not Reproduce or Disclose ---                   */
/****************************************************************************/
#if TIFFPROG
   #define ICON_NAME "Tiff"
#elif PCXPROG
   #define ICON_NAME "Pcx"
#else 
   #define ICON_NAME "Tiff"
#endif

   #define ICON_DOC "Document"

#if TIFFPROG && SAMPLE
   #define CAPTION_TEXT "Tiff SDK For Windows - sample"
   #define VERSION "Version 2.D"
   #define DEMO_MSG 

#elif TIFFPROG && DEMO
   #define CAPTION_TEXT "Tiff SDK For Windows - demo"
   #define VERSION "Demo version 2.D"
   #define DEMO_MSG MessageBox(NULL, \
                              (LPSTR)"This is a demo version of TIFF and Image SDK For Windows." \
                              "\nFor information please contact Black Ice Software Inc." \
                              "\nPhone (914) 277-7006  Fax (914) 276-8418" \
                              "\nCopyright (c) 1989-1991 Black Ice Software Inc.", \
                              (LPSTR)"Demo restriction",   \
                              MB_OK);

#elif PCXPROG && SAMPLE
   #define CAPTION_TEXT "PCX SDK For Windows - sample"
   #define VERSION "Version 2.A"
   #define DEMO_MSG 

#elif PCXPROG && DEMO
   #define CAPTION_TEXT "PCX SDK For Windows - demo"
   #define VERSION "Demo version 2.A"
   #define DEMO_MSG MessageBox(NULL, \
                              (LPSTR)"This is a demo version of PCX and Image SDK For Windows." \
                              "\nFor information please contact Black Ice Software Inc." \
                              "\nPhone (914) 277-7006  Fax (914) 276-8418" \
                              "\nCopyright (c) 1989-1991 Black Ice Software Inc.", \
                              (LPSTR)"Demo restriction",   \
                              MB_OK);

#else
   #define CAPTION_TEXT ""
   #define VERSION "Version X.X"
   #define DEMO_MSG 
#endif



#define DISP_NORMAL  0
#define DISP_ZOOMED  1
#define DISP_PREVIEW 2

typedef struct TagDECOMPRESS
    {
    HANDLE        hChain;           // Image handle,
    int           nImage;           // image in the chain (zero based)
    WORD          dwCompression;    // Decompression type
	DWORD				  dwRowsPerStrip;		// Number of rows in a strip.
    WORD          wLinesDecomp;     // Lines decompressed
    WORD          nImgHeight;       // Image height      
   } DECOMPRESS;

typedef struct _gPage
   {
      // window handlers
      HWND hWndDraw;          // handler of drawing child window
      HWND hWndMain;          // handler of main applications Window

      RECT rWhole;            /* Whole useful drawing surface in 1/10 mm-s*/
      RECT rActDraw;          /* actual useful drawing surface in 1/10 mm-s */

      BOOL bNeedSave;         // TRUE if drawing need save
      char szFileName[150];   // current filename
      OFSTRUCT of;            // OFSTRUCT of current file

      HBITMAP hCurrentBitmap; // handle of a bitmap used in clipboard procedures
      HANDLE  hBitmapInfo;    // bitmap info structure

      RECT Rect;              // temporary storage tracing mousemovement
      int  nDispFormat;
      int  nFormatID;         // fileformat of image
      
      int  nWindowXExt;  
      int  nWindowYExt;
      int  nViewportXExt;
      int  nViewportYExt;

      DECOMPRESS dDecomp;

   } GPAGETYPE;

// passing data to call back function
typedef struct  TagTIFFLINEDATA {
        HDC     hDC;
        HBITMAP hBitmap;
        HANDLE  hBitmapInfo;
        } TIFFLINEDATA; 

// This is a monochrome bitmap info structure. 
typedef struct tagBWBITMAPINFO {

      BITMAPINFOHEADER   bmiHeader;
      RGBQUAD            bmiColors[2];

      } BWBITMAPINFO;



