/****************************************************************************/
/* pcx.h      (c) Copyright Black Ice Software Inc.  1989 - 1991            */
/*                   All Rights Reserved                                    */
/*                   Unpublished and confidential material.                 */
/*                   --- Do not Reproduce or Disclose ---                   */
/****************************************************************************/
typedef struct tag_pcx_header
{
 unsigned char Manufacturer;
 unsigned char Version;
 unsigned char Encoding;
 unsigned char BitsPerPixel;
 int  nLeft;  /*picture dimensions*/
 int  nTop;
 int  nRight;
 int  nBottom;
 int  nHorzDPI;	/*horizontal resolution (dpi)*/
 int  nVertDPI;
 unsigned char Colormap[48];
 char Reserved;
 char NumOfPlanes;
 int  nBytesPerLine;
 int	nPaletteInfo;
 int  nHorzScrSize;
 int  nVertScrSize;
 char Dummy[54];
} PCX_HEADER;


// sc defines
#define USE_PCX_PALETTE       // put PCX color table into DIB color table
#define HANDS_OFF_SCREEN      // caller decides what to write to the screen


// -- error reports of PCXInfo
#define PCX_OK	               1
#define PCX_BUF_ALLOC         2	 // unable to allocate buffers
#define PCX_UNKNOWN_VERSION   3 	 // uninterpreatable version
#define PCX_UNCKNOWN_ENCODING 4	 // possibly PCX, but doesn't use ZSoft encoding
#define PCX_FILEOPEN				5   // unable to open file
#define PCX_BITMAP				6   // unable to create bitmap
#define PCX_CLIP_OPEN		   7   // unable to open clipboard
#define PCX_HDC					8   // unable to create compatible DC
#define PCX_TOO_SPECIAL_FORMAT 9  // too hardware dependent bitmap

#ifdef USE_PCX_PALETTE
#define PCX_BAD_PALETTE       10  // error in reading palette info
#endif


//--- constants to identify which colormap to create
#define WINDOWS_ON_CGA	1
#define WINDOWS_ON_HERC	2
#define WINDOWS_ON_EGA	3
#define WINDOWS_ON_VGA	4

#ifdef  HANDS_OFF_SCREEN
BOOL    FAR PASCAL PCXInfo(LPSTR lpszFileName, PCX_HEADER far *lpInfo,int far *nErrCode, BOOL msgOK);
HANDLE  FAR PASCAL LoadPCXIntoDIB(LPSTR lpszFileName, int far *nErrCode, BOOL sBar);
HBITMAP FAR PASCAL LoadPCXIntoBitmap(HDC hDC, LPSTR lpszFileName, int far *nErrCode, BOOL sBar);
BOOL    FAR PASCAL PutPCXToClipboard(HWND hWnd, HDC hDC,LPSTR lpszFileName,int far * nErrCode, BOOL sBar);

#else

BOOL    FAR PASCAL PCXInfo(LPSTR lpszFileName, PCX_HEADER far *lpInfo,int far *nErrCode);
HANDLE  FAR PASCAL LoadPCXIntoDIB(LPSTR lpszFileName, int far *nErrCode);
HBITMAP FAR PASCAL LoadPCXIntoBitmap(HDC hDC, LPSTR lpszFileName, int far *nErrCode);
BOOL    FAR PASCAL PutPCXToClipboard(HWND hWnd, HDC hDC,LPSTR lpszFileName,int far * nErrCode);
#endif

int     FAR PASCAL LoadPCX(BOOL bSign, HDC hDC, LPSTR lpszFileName);
BOOL    FAR PASCAL SaveBitmapInPCXFormat(HBITMAP hBitmap, LPSTR lpszFileName);

