/****************************************************************************/
/* tdemo.c   (c) Copyright Black Ice Software Inc.  1989 - 1991             */
/*                   All Rights Reserved                                    */
/*                   Unpublished and confidential material.                 */
/*                   --- Do not Reproduce or Disclose ---                   */
/****************************************************************************/
/*****************************************************************************
 Module
         c:\test\tiff\tdemo.c

 Revision
         $Revision:   1.4  $

 Description
         main module of TIFF 5.0 demo application

 Notes
         

 
   $Log:   E:/c/ujtdemo/tdemo.c_v  $
 * 
 *    Rev 1.4   29 Jan 1991 18:34:02   Hrasko_Gabor
 * Mapping mode and zooming is improved.
 * 
 *    Rev 1.3   29 Jan 1991  9:09:52   Hrasko_Gabor
 * DeleteBitmap() function was introduced.
 * Plette handling code was removed (it was commented out anyway).
 * 
 *    Rev 1.2   28 Jan 1991 12:51:08   Hrasko_Gabor
 * The main window function is modularized.
 * Modification check is worked out.
 * 
 *    Rev 1.1   24 Jan 1991 10:39:30   Hrasko_Gabor
 * This is a reference version.
 * 
 *    Rev 1.0   16 Jan 1991  9:59:16   Hrasko_Gabor
 * Initial revision.
 * 
 *    Rev 1.16   04 Sep 1990 10:56:16   Lorincz_Gabor
 * mending solitare points was improved
 * 
 *    Rev 1.15   03 Sep 1990 15:36:18   Lorincz_Gabor
 * zoom efficiency and errorchecking was improved
 * 
 *    Rev 1.14   27 Aug 1990 17:01:44   Lorincz_Gabor
 * EXIT menuitem was added
 * 
 *    Rev 1.13   27 Aug 1990 14:32:10   Lorincz_Gabor
 * nem menupoints
 * 
 *    Rev 1.12   21 Aug 1990 12:53:40   Lorincz_Gabor
 * menuitem to select default file format was added
 * 
 *    Rev 1.11   20 Aug 1990 12:13:56   Lorincz_Gabor
 * scroll was improved, "linedown/up" means 1/10 of actually displayse area
 * 
 *    Rev 1.10   20 Aug 1990 10:07:52   Lorincz_Gabor
 * I think, nothing important
 * 
 *    Rev 1.9   28 Jul 1990 20:14:56   Lorincz_Gabor
 * 
 *    Rev 1.8   25 Jul 1990 10:48:18   Lorincz_Gabor
 * 
 *    Rev 1.7   20 Jul 1990 20:45:04   Lorincz_Gabor
 * graying/enabling ALL menupoints and receiving WM_SIZE message were added
 * 
 *    Rev 1.6   20 Jul 1990 19:29:40   Lorincz_Gabor
 * horizontal scroll was added
 * 
 *    Rev 1.5   14 Jul 1990  8:33:00   Lorincz_Gabor
 * zoom refinement
 * 
 *    Rev 1.4   13 Jul 1990 13:37:12   Lorincz_Gabor
 * vertical scrolling is OK
 * 
 *    Rev 1.3   13 Jul 1990 12:11:30   Lorincz_Gabor
 * scrolling was refined, but some error arised
 * 
 *    Rev 1.2   12 Jul 1990 17:58:54   Lorincz_Gabor
 * vertical scrolling was added
 * 
 *    Rev 1.1   12 Jul 1990 16:11:22   Lorincz_Gabor
 * 
 * nothing important
 * 
 *    Rev 1.0   11 Jul 1990  7:43:46   Lorincz_Gabor
 * Initial revision.
*****************************************************************************/



//------------------------------- Include Files -------------------------------

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <memory.h>
#include <windows.h>
#include "data.h"
#include "tdemo.h"          
#include "fio.h"
#include "f_openna.h"
#include "clipboar.h"
#include "snap.h"
#include "bitmani.h"
#include "formats.h"

#ifdef TIFFPROG
   #include "tiff.h"
   #include "tiffdlg.h"
#endif

#ifdef PCXPROG
   #include "pcx.h"
#endif

//----------------------------- External Functions ----------------------------

extern HANDLE FAR PASCAL DefaultFileFormatDlg(HWND hDlg, unsigned message, WORD wParam, LONG lParam);
extern int    FAR PASCAL BmInfoDlgFn(HWND hDlg, WORD wMsg, WORD wParam, DWORD lParam);
extern int    FAR PASCAL FlushTiffLine(LPSTR lpLineBuff, int nLine, LONG lParam);
extern long   FAR PASCAL StatusWndProc(HWND hWnd, unsigned message, WORD wParam, LONG lParam);
extern VOID   ErrorMessage(HWND hWnd, HANDLE hInst, int ErrorId );
extern VOID   ShowStatus(HWND hWnd, int StringId, int Style);

//----------------------------- External Variables ----------------------------

//------------------------------- Module Defines ------------------------------

// child ids
#define ID_STATUS             100
#define NUMKEYS (sizeof(KeyScroll) / sizeof(KeyScroll[0]))
#define UNTITLED "noname"

//-------------------------------- Module Types -------------------------------

//------------------------------ Global Functions -----------------------------

VOID MakeMDIClient(HWND hWnd);
VOID MenuMessage(unsigned message, WORD wParam, LONG lParam);
VOID MakeStatusBar(HWND hWnd);
VOID CloseAllChildren(VOID);
BOOL IsEnoughResources(VOID);
HWND CreateImageDisplay(VOID);

HWND MakeMDIChild(
                  LPSTR szClassName,
                  LPSTR szTitle,
                  DWORD dwStyle, 
                  short x,
                  short y,
                  short nWidth,
                  short nHeight,
                  LONG  lParam
                  );

//------------------------------ Global Variables -----------------------------

HANDLE hInst;              /* current instance              */
HANDLE hAccTable;          // accelerator table
HPALETTE hCurrentPal;
GPAGETYPE  gPage;
int        xChar, yChar, yExtLeading;
HWND   hWndFrame;
HWND   hWndMDIClient;
HWND   hWndStatus;
HANDLE hUserLib;
BOOL   bDecompG4;
int    nDefaultFormat;


//------------------------------ Module Functions -----------------------------

int  AskForSave(GPAGETYPE far *pPage);
BOOL ScrollImage(int nVert, int nHoriz, GPAGETYPE far *pPage);
VOID GetBitmapDimensions(GPAGETYPE far *pPage);
VOID InitMenu(HWND hWnd);
VOID SetScrollBars(GPAGETYPE far *pPage);
VOID PaintBitmap(HWND hWnd, GPAGETYPE far *pPage);
VOID UpdateBitmap(GPAGETYPE far *pPage);
long FAR PASCAL ImageWndProc(HWND hWnd,unsigned message,WORD wParam,LONG lParam);

//------------------------------ Module Variables -----------------------------

int nMapMode;
int nStretchBltMode = COLORONCOLOR;

struct {
   WORD   wVirtKey;
   int    iMessage;
   WORD   wRequest;
   }
   KeyScroll[] = {
   VK_HOME,      WM_VSCROLL,   SB_TOP,
   VK_END,       WM_VSCROLL,   SB_BOTTOM,
   VK_PRIOR,     WM_VSCROLL,   SB_PAGEUP,
   VK_NEXT,      WM_VSCROLL,   SB_PAGEDOWN,
   VK_UP,        WM_VSCROLL,   SB_LINEUP,
   VK_DOWN,      WM_VSCROLL,   SB_LINEDOWN,
   VK_LEFT,      WM_HSCROLL,   SB_PAGEUP,
   VK_RIGHT,     WM_HSCROLL,   SB_PAGEDOWN
   };

char szImgPropName [] ="IMG";

//-------------------------------- Module Code --------------------------------

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, 
                              LPSTR lpCmdLine, int nCmdShow)
{
MSG msg;                                // message

    lpCmdLine;

    if (!hPrevInstance)                  // Other instances of app running ? 
       if (!InitApplication(hInstance))  // Initialize shared things.
          return (FALSE);                // Exits if unable to initialize.

    // Perform initializations that apply to a specific instance

   hInst = hInstance;

   hWndFrame = CreateWindow
   (
      "BLACK_ICE",
      CAPTION_TEXT,
      WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
      0,
      0,
      GetSystemMetrics(SM_CXSCREEN),
      GetSystemMetrics(SM_CYSCREEN) - GetSystemMetrics(SM_CYICON),
      NULL,
      NULL,
      hInstance,
      NULL      
   );

    hAccTable=LoadAccelerators(hInst,"tdemo");
    if (!hAccTable)
         return FALSE;

    hUserLib = LoadLibrary("user.exe");
    FreeLibrary(hUserLib);

    if (hUserLib < 32) {
        DestroyWindow(hWndFrame);
        return FALSE;
    }

    // Make the window visible; update its client area and return "success".

    ShowWindow(hWndFrame, nCmdShow);  
    UpdateWindow(hWndFrame);

    // -------------------- INITALIZE IMPORTANT VARIABLES -----------------

#ifdef PCXPROG
    nDefaultFormat = PCX_FORMAT;
#else
    nDefaultFormat = TIFF_FORMAT;
#endif

    // Acquire and dispatch messages until a WM_QUIT message is received.

    while (GetMessage(&msg,NULL,NULL,NULL)) {

      if (!TranslateMDISysAccel (hWndMDIClient, &msg) &&
          !TranslateAccelerator(hWndFrame,hAccTable,&msg)) {

          TranslateMessage(&msg);      // Translates virtual key codes.
          DispatchMessage(&msg);       // Dispatches message to window.
      }
    }

    return (msg.wParam);      // Returns the value from PostQuitMessage.
}



/*****************************************************************************
 Function
         InitApplication

 Parameters
         hInstance         current instance.

 Returns
         TRUE on success, FALSE if failed.

 Description
         Registers window classes.

 Notes
         None.

 Author
         Lorincz_Gabor, 07/06/90 10:06
*****************************************************************************/

BOOL InitApplication(HANDLE hInstance)
{
WNDCLASS  wc;
char         szClass[CLASSNAME_L+1];

    // Fill in window class structure with parameters that describe the
    // main window. 

    wc.style = CS_HREDRAW|CS_VREDRAW|CS_BYTEALIGNCLIENT|CS_BYTEALIGNWINDOW;
                                        /* Class style(s).                    */
    wc.lpfnWndProc = MainWndProc;       /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra = 0;                  /* No per-class extra data.           */
    wc.cbWndExtra = 0;                  /* No per-window extra data.          */
    wc.hInstance  = hInstance;          /* Application that owns the class.   */
    wc.hIcon      = LoadIcon(hInstance,ICON_NAME);
    wc.hCursor    = LoadCursor(NULL, IDC_ARROW);
    /* Create a green brush for the background */
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);      
    wc.lpszMenuName  = "TDemoMenu";     /* Name of menu resource in .RC file. */
    wc.lpszClassName = "BLACK_ICE";     /* Name used in call to CreateWindow. */
    
    /* Register the window class and return success/failure code. */
    if (!RegisterClass(&wc))
         return FALSE;

    // Image display windows

    wc.style         = CS_HREDRAW|CS_VREDRAW|CS_BYTEALIGNCLIENT|CS_BYTEALIGNWINDOW;
    wc.lpfnWndProc   = ImageWndProc;    /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra    = 0;               /* No per-class extra data.           */
    wc.cbWndExtra    = 0;               /* No per-window extra data.          */
    wc.hInstance     = hInstance;       /* Application that owns the class.   */
    wc.hIcon         = LoadIcon(hInstance,ICON_DOC);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);

    /* Create a green brush for the background */
    wc.hbrBackground = CreateSolidBrush( PALETTERGB( 0, 128, 128 ) );      
    wc.lpszMenuName  = NULL;            /* Name of menu resource in .RC file. */
    wc.lpszClassName = "TDemoWinClass"; /* Name used in call to CreateWindow. */
    
   if (!RegisterClass(&wc))
       return FALSE;

   // status bar
   wc.style         = CS_HREDRAW | CS_VREDRAW;                  
   wc.lpfnWndProc   = StatusWndProc;     
   wc.cbClsExtra    = 0;
   wc.cbWndExtra    = STATCBWNDEXTRA;
   wc.hInstance     = hInstance;
   wc.hIcon         = NULL;
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = COLOR_BTNFACE + 1; 
   wc.lpszMenuName  =  NULL;
   if (!LoadString(hInstance, IDS_STATUSCLASS, szClass, CLASSNAME_L))
   {
      ErrorMessage(NULL, hInstance, IDS_LOWMEMORY);
      return FALSE;
   }
   wc.lpszClassName = szClass;


    /* Register the window class and return success/failure code. */
    return (RegisterClass(&wc));
}

/*****************************************************************************
 Function
         CreateImageDisplay

 Parameters
        VOID

 Returns
         TRUE on success, FALSE if failed.

 Description
         Creates and MDI child windows for the application and does 
        all other initialization.

 Notes
         None.

 Author
         Jozsef_Nemeth, 12/10/91 10:08
*****************************************************************************/

HWND CreateImageDisplay()
{
HWND hWnd;               // Main window handle.
int  xScreen, yScreen;
GPAGETYPE LocalPage;

    // Save the instance handle in static variable, which will be used in
    // many subsequence calls from this application to Windows.          


    xScreen = GetSystemMetrics(SM_CXSCREEN);
    yScreen = GetSystemMetrics(SM_CYSCREEN);

    // -------------------- INITALIZE IMPORTANT VARIABLES -----------------

    gPage.nDispFormat = DISP_NORMAL;

    // The created child window will distroy the context of gPage
    LocalPage = gPage;

    // do not process first repaint message
    gPage.hCurrentBitmap = NULL;

    // Make the window visible; update its client area and return "success".
    // Create a main window for this application instance.
    hWnd = MakeMDIChild("TDemoWinClass", 
                        CAPTION_TEXT, 
                        WS_HSCROLL | WS_VSCROLL | WS_CLIPCHILDREN,
                        CW_USEDEFAULT, CW_USEDEFAULT, 
                        CW_USEDEFAULT, CW_USEDEFAULT, 
                        0L);

    // If window could not be created, return "failure".

    if (!hWnd)
      return (FALSE);

    // restore global data.
    gPage = LocalPage;

    gPage.hWndMain = gPage.hWndDraw = hWnd;

    return (hWnd);               
}


/*****************************************************************************
 Function
         MainWndProc

 Parameters
         normal window function patameters

 Returns
         long

 Description
         callback function of main window

 Notes
         None.

 Author
         Lorincz_Gabor, 07/06/90 10:09
*****************************************************************************/
long FAR PASCAL MainWndProc(HWND hWnd, unsigned message, 
                                       WORD wParam, LONG lParam)
{
BOOL    bCallDefProc = FALSE;
FARPROC lpProc;

   switch (message)
   {
      case WM_CREATE:
        {
         TEXTMETRIC     tm;
         HDC            hDC;
         int            iSocket = 0;

         memset(&tm, 0, sizeof(TEXTMETRIC));

         hDC = GetDC(hWnd);
         GetTextMetrics(hDC, &tm);
         xChar = tm.tmAveCharWidth;
         yChar = tm.tmHeight;
         yExtLeading = tm.tmExternalLeading;
         ReleaseDC(hWnd, hDC);

         MakeMDIClient(hWnd);

         MakeStatusBar(hWnd);

         SetFocus(hWnd);
        }
      break;

      case WM_SIZE:
      {
         int   yClient = HIWORD(lParam);
         int   xClient = LOWORD(lParam);
         int   iStatusHeight = 0;

         if (hWndStatus)
         {
            iStatusHeight = yChar * 3 / 2 + GetSystemMetrics(SM_CYDLGFRAME) * 2;
            MoveWindow(   hWndStatus, 0, yClient - iStatusHeight,
                            xClient, iStatusHeight, TRUE);

            MoveWindow(   hWndMDIClient, 0, 0,   xClient, yClient - iStatusHeight, TRUE );
         }
      }
      break;

      case WM_INITMENU:
         // set menuitems according to real state.
         InitMenu(hWnd);
      break;

      case WM_MENUSELECT:
         MenuMessage(message, wParam, lParam);
      break;

      case WM_COMMAND:

         // If a child is being activated via the "Window" menu, let
         // the DefFrameProc handle it.
         if (wParam >= IDM_ENDMENU) {
            bCallDefProc = TRUE;
            break;
         }

         switch (wParam)
         {
            case IDM_EXIT:
               PostMessage(hWnd, WM_CLOSE, 0, 0L);
            break;

            case IDM_WINDOWTILE:
               SendMessage (hWndMDIClient, WM_MDITILE, 0, 0L);
            break;

            case IDM_WINDOWCASCADE:
               SendMessage (hWndMDIClient, WM_MDICASCADE, 0, 0L);
            break;

            case IDM_WINDOWICONS:
               SendMessage (hWndMDIClient, WM_MDIICONARRANGE, 0, 0L);
            break;

            case IDM_WINDOWCLOSEALL:
               CloseAllChildren();
            break;

          case IDM_OPEN      :
            {

            // assume it's ok to end session
            DWORD  dwResult = TRUE;
            HWND   hChild   = GetWindow (hWndMDIClient, GW_CHILD);


            // -------------------- INITALIZE IMPORTANT VARIABLES ------------

            gPage.nDispFormat = DISP_NORMAL;

            if (hChild == NULL) {
                // load image
                LoadFunc();
                break;
            }

            //ask each child if it's finished to decompress
            do
            {
               /* Do not ask caption bars of iconic mdi children */
               if (GetWindow (hChild, GW_OWNER) != NULL)
                  continue;

               dwResult = SendMessage(hChild, PM_DECOPM_END, wParam, 0L);
               // if not finished to decompress, don't ask the other children
               if (dwResult) {
                  // Cann't open file until decompression is finished
                  ShowStatus(hWndStatus, IDS_OPENDECOMPRESS, ST_READY);
                  break;
               }

            } while (( hChild = GetWindow (hChild, GW_HWNDNEXT)) != NULL);

            if (!dwResult)
               // load image
               LoadFunc();
            }
          break;

          case IDM_DECOMP      :
            {
            HMENU   hMenu;
            hMenu=GetMenu(hWndFrame);
            if (GetMenuState(GetMenu(hWndFrame),IDM_DECOMP,MF_BYCOMMAND) & MF_CHECKED)
               { 
               bDecompG4 = FALSE;
               CheckMenuItem(hMenu,wParam,MF_UNCHECKED);
               }
            else
               { 
               bDecompG4 = TRUE;
               CheckMenuItem(hMenu,wParam,MF_CHECKED);
               }
            }
          break;

          case IDM_FILEFORMAT:
             lpProc = MakeProcInstance(DefaultFileFormatDlg, hInst);
             DialogBoxParam(hInst,           // current instance
                            "D_FILE",        // resource to use 
                            hWnd,            // parent handle     
                            lpProc,          // callback fn instance address
                            0l);
             FreeProcInstance(lpProc);
             break;

          case IDM_ABOUT:
             lpProc = MakeProcInstance(About, hInst);
             DialogBox(hInst,                   // current instance
                       "AboutBox",              // resource to use 
                       hWnd,                    // parent handle     
                       lpProc);                 // About() instance address
             FreeProcInstance(lpProc);
             break;

            default:
            {
               // if a child is being activated via the "Window" menu,
               // let the DefFrameProc handle it
               DWORD dwRes = SendMessage(hWndMDIClient, WM_MDIGETACTIVE, 0, 0L);

               HWND  hWndActiveChild = LOWORD(dwRes);

               if (IsWindow(hWndActiveChild))
                  SendMessage(hWndActiveChild, message, wParam, lParam);
               else
                  bCallDefProc = TRUE;
            }
         }   /* end of WM_COMMAND */
      break;

      case WM_CLOSE:
         /* 
            before closing the app, ask the MDI children if it's ok.
            wParam is TRUE because the Windows session is NOT being ended
         */

         bCallDefProc = (BOOL)SendMessage(hWnd, WM_QUERYENDSESSION, TRUE, 0L);
         if (bCallDefProc) {
            SendMessage(hWnd, WM_ENDSESSION, TRUE, 0L);
         }
      break;

      case WM_QUERYENDSESSION:
      {
         /*
            if called by Windows, wParam is zero. Otherwise, wParam is TRUE
         */

         // assume it's ok to end session
         DWORD dwResult = TRUE;
         WORD   wTemp = 0;
         HWND   hChild = GetWindow (hWndMDIClient, GW_CHILD);

         if (hChild == NULL)
            return DefFrameProc (hWnd, hWndMDIClient, message, wParam, lParam);

         //ask each child if it's ok to terminate
         do
         {
            /* Do not ask caption bars of iconic mdi children */
            if (GetWindow (hChild, GW_OWNER) != NULL)
               continue;

            dwResult = SendMessage(hChild, WM_QUERYENDSESSION, wParam, 0L);
            // if not ok, don't ask the other children
            if (dwResult == FALSE)
               break;

         } while (( hChild = GetWindow (hChild, GW_HWNDNEXT)) != NULL);

         /*
            if any child said No, tell the other children that the session is
            NOT being terminated
         */
         if (dwResult == FALSE)
         {
            wTemp = hChild;
            hChild = GetWindow (hWndMDIClient, GW_CHILD);
            do
            {
               // if this is the child that said no, stop
               if (wTemp == hChild)
                  break;

               /* Do not ask caption bars of iconic mdi children */
               if (GetWindow (hChild, GW_OWNER) != NULL)
                  continue;

               // tell children we are not ending the session (wParam is False)
               SendMessage(hChild, WM_ENDSESSION, FALSE, 0L);
            } while (( hChild = GetWindow (hChild, GW_HWNDNEXT)) != NULL);
         }
         return dwResult;
      }

      case WM_ENDSESSION:
      {
         HWND   hChild = GetWindow (hWndMDIClient, GW_CHILD);

         if (hChild == NULL)
            return DefFrameProc (hWnd, hWndMDIClient, message, wParam, lParam);

         //tell each mdi child whether the session is ending
         do
         {
            /* Do not ask caption bars of iconic mdi children */
            if (GetWindow (hChild, GW_OWNER) != NULL)
               continue;

            SendMessage(hChild, WM_ENDSESSION, wParam, 0L);
         } while (( hChild = GetWindow (hChild, GW_HWNDNEXT)) != NULL);
      }
      return NULL;

      case WM_DESTROY:        

         PostQuitMessage(0);
      break;

      default:
         bCallDefProc = TRUE;
   }

   if (bCallDefProc)
      return DefFrameProc (hWnd, hWndMDIClient, message, wParam, lParam);
   else
      return NULL;
}

long FAR PASCAL ImageWndProc(HWND hWnd,unsigned message,WORD wParam,LONG lParam)
{
FARPROC lpProc;
HMENU   hMenu;
HBITMAP hClipBmp;
HDC     hDC;
RECT    rClient;
int     nLogCliExt,i;
BOOL    bRedraw  = FALSE;
BOOL    bDefProc = FALSE;
GPAGETYPE *pPage;

HANDLE  hMem = GetProp(hWnd, (LPSTR) szImgPropName);
   /*
      NOTE: (hMem == NULL) is a VALID state!  It means either:
         1) We just got our WM_CREATE message
         2) We already got our ID_CANCEL message
   */
   if (hMem) {
      if ((pPage = (GPAGETYPE *) LocalLock(hMem)) == NULL) {
        return TRUE;
      }
   }

   switch (message) {

      case WM_COMMAND:      // message: command from application menu.

         switch (wParam)
            {

            case IDM_SAVE      :
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  SaveFunc(pPage);
                  }
               break;

            case IDM_SAVEAS   :
               if ((pPage->hCurrentBitmap!=NULL) &&
                  (GetSaveAsFileName((GPAGETYPE far *)pPage, (LPSTR)pPage->szFileName)))
                  {
                     if (pPage->dDecomp.wLinesDecomp)
                     {
                     // decompression is not finished yet
                     ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                     }
                     else
                     {
                     SaveFunc(pPage);
                     }
                  }
               break;


            case IDM_EXIT      :
               // Here it is necessary to ask the user 
               // for saving unsaved bitmap.
               if (AskForSave(pPage) != IDCANCEL)
                  {
                  DestroyWindow(hWnd);
                  }
               break;


            case IDM_COPY      :
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                     {
                     // decompression is not finished yet
                     ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                     }
                  else
                     {
                     CopyToClipBoard(pPage);
                     }
               break;

            case IDM_CUT      :
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  if (OpenClipboard(hWnd) && EmptyClipboard())
                     {
                     SetClipboardData( CF_BITMAP, pPage->hCurrentBitmap );
                     CloseClipboard();
                     // The bitmap handle is not our property any more.
                     pPage->hCurrentBitmap = NULL; 
                     ReplaceBitmap(NULL,TRUE,TRUE, pPage);
                     }
                  else
                     {
                     MessageBeep(100);
                     }
                  }
               break;

            case IDM_DELETE   :
               if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
               else
                  {
                  if (AskForSave(pPage) != IDCANCEL)
                     {
                     ReplaceBitmap(NULL,TRUE,TRUE, pPage);
                     } 
                  }
               break;

            case IDM_PASTE      :// paste from clipboard
               if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
               else
                  {
                  if (AskForSave(pPage) != IDCANCEL)
                     {
                     hClipBmp = NULL;
                     if (IsClipboardFormatAvailable(CF_TEXT))
                        hClipBmp = PasteText(hWnd);
   
                     else if (IsClipboardFormatAvailable(CF_BITMAP))
                        hClipBmp = PasteBits(hWnd);
                        
                     //else if (IsClipboardFormatAvailable(CF_METAFILEPICT))
                     //   hClipBmp = PasteMetaFile(hWnd);
                        
                     
                     if(hClipBmp != NULL)
                        {
                        ReplaceBitmap(hClipBmp,TRUE,TRUE, pPage);
                        pPage->bNeedSave = TRUE;
                        }

                     }
                  }
               break;


            case IDM_ROTATE_90:
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                     {
                     // decompression is not finished yet
                     ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                     }
                  else
                     {
                     HBITMAP hTempBitmap;

                     hTempBitmap = RotateBitmap90(pPage->hCurrentBitmap);
                     if(hTempBitmap != NULL)
                        {
                        ReplaceBitmap(hTempBitmap,FALSE,TRUE, pPage);
                        pPage->bNeedSave = TRUE;
                        }
                     else
                        MessageBeep(100);
                     }

               break;

            case IDM_ROTATE_180   :
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  if (RotateBitmap180(pPage->hCurrentBitmap))
                     {
                     UpdateBitmap(pPage);
                     pPage->bNeedSave = TRUE;
                     }
                  else
                     MessageBeep(0);
                  }
               break;

            case IDM_FLIP_VERT:
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  if (FlipBitmapVertical(pPage->hCurrentBitmap))
                     {
                     UpdateBitmap(pPage);
                     pPage->bNeedSave = TRUE;
                     }
                  else
                     MessageBeep(0);
                  }
               break;

            case IDM_FLIP_HORIZ:
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  if (FlipBitmapHorizontal(pPage->hCurrentBitmap))
                     {
                     UpdateBitmap(pPage);
                     pPage->bNeedSave = TRUE;
                     }
                  else
                     MessageBeep(0);
                  }
               break;

            case IDM_INVERT   :
               if (pPage->hCurrentBitmap!=NULL )
                  if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
                  else
                  {
                  if (InvertBitmap(pPage->hCurrentBitmap))
                     {
                     UpdateBitmap(pPage);
                     pPage->bNeedSave = TRUE;
                     }
                  else
                     MessageBeep(0);
                  }
               break;

            case IDM_ZOOMIN   :
               hMenu=GetMenu(hWndFrame);
               if(GetMenuState(GetMenu(hWndFrame),IDM_ZOOMIN,MF_BYCOMMAND) & MF_CHECKED)
                  { 
                  CheckMenuItem(hMenu,wParam,MF_UNCHECKED);
                   SetClassWord(hWnd,GCW_HCURSOR,LoadCursor(NULL,IDC_ARROW));
                  }
               else
                  { 
                  CheckMenuItem(hMenu,wParam,MF_CHECKED);
                   SetClassWord(hWnd,GCW_HCURSOR,LoadCursor(hInst,"zoom"));
                  }

               break;

            case IDM_PREVIEW :
               pPage->nDispFormat = DISP_PREVIEW;
               UpdateBitmap(pPage);
               break;

            case IDM_NORMAL :
               pPage->nDispFormat = DISP_NORMAL;
               UpdateBitmap(pPage);
               break;

            case IDM_BLACK : 
               nStretchBltMode = BLACKONWHITE;
               goto DISP;
                           
            case IDM_WHITE : 
               nStretchBltMode = WHITEONBLACK;
               goto DISP;
                           
            case IDM_COLOR : 
               nStretchBltMode = COLORONCOLOR;
               DISP:
               hMenu=GetMenu(hWndFrame);
               CheckMenuItem(hMenu,IDM_BLACK,MF_UNCHECKED);
               CheckMenuItem(hMenu,IDM_WHITE,MF_UNCHECKED);
               CheckMenuItem(hMenu,IDM_COLOR,MF_UNCHECKED);
               CheckMenuItem(hMenu,wParam,MF_CHECKED);
               InvalidateRect(hWnd,NULL,FALSE);
               UpdateWindow(hWnd);
               break;
                           
            case IDM_EXT_GRAB:
            case IDM_GRAB    :
               if (pPage->dDecomp.wLinesDecomp)
                  {
                  // decompression is not finished yet
                  ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
                  }
               else
                  {
                  if (AskForSave(pPage) != IDCANCEL)
                     {
                     Snap(hWnd,(wParam == IDM_EXT_GRAB), pPage);
                     pPage->bNeedSave = TRUE;
                     }
                  }
               break;

            case IDM_DIMENSIONS:
               lpProc = MakeProcInstance(BmInfoDlgFn,hInst);

               DialogBox(hInst,          // current instance
                         "BmInfo",       // resource to use 
                         hWnd,           // parent handle     
                         lpProc);        // callback fn instance address 
               FreeProcInstance(lpProc);
               break;
          
            default:
               bDefProc = TRUE;
               break;

            }   // End of 'WM_COMMAND' switch (menu commands).

         break;

      case WM_RBUTTONDOWN:
      case WM_LBUTTONDOWN:
         if (pPage->dDecomp.wLinesDecomp)
            {
            // decompression is not finished yet
            ShowStatus(hWndStatus, IDS_NODECOMPRESS, ST_READY);
            }
         else
            {
            // Zooming starts if we are in 'Zoom' mode.
            if(GetMenuState(GetMenu(hWndFrame),IDM_ZOOMIN,MF_BYCOMMAND) & MF_CHECKED)
               {
               Zoom(hWnd,lParam, pPage);
               }
            }   
         break;
   
      case WM_DESTROY:     

         // Erases previous bitmap if any. 
         // It is neccessary to free the memory it occupies.
	     DeleteBitmap(TRUE, pPage);

         // end of session remove property
         if (hMem) {
             RemoveProp(hWnd, (LPSTR) szImgPropName);
             while(LocalFlags(hMem) & LMEM_LOCKCOUNT)
                  LocalUnlock(hMem);
             LocalFree(hMem);
             hMem = NULL;
          }
         break;
   
      case WM_HSCROLL:
         GetClientRect(hWnd,(LPRECT)&rClient);
         hDC=GetDC(hWnd);
         SetWindowView(hDC, pPage);
         DPtoLP(hDC,(LPPOINT)&rClient,2);
         ReleaseDC(hWnd,hDC);
         nLogCliExt=abs(rClient.right-rClient.left);
         bRedraw = FALSE;
   
         switch (wParam)
            {
            case SB_TOP:
               bRedraw = ScrollImage(0,-pPage->rActDraw.left, pPage);
               break;

            case SB_BOTTOM:
               bRedraw = ScrollImage(0,pPage->rWhole.right-pPage->rActDraw.right, pPage);
               break;

            case SB_LINEUP:
               bRedraw = ScrollImage(0,-min(nLogCliExt/10+1,pPage->rActDraw.left), pPage);
               break;

            case SB_LINEDOWN:
               bRedraw = ScrollImage(0,min(nLogCliExt/10+1,pPage->rWhole.right-pPage->rActDraw.right), pPage);
               break;

            case SB_PAGEUP:
               bRedraw = ScrollImage(0,-min(nLogCliExt/2+1,pPage->rActDraw.left), pPage);
               break;

            case SB_PAGEDOWN:
               bRedraw = ScrollImage(0,min(nLogCliExt/2+1,pPage->rWhole.right-pPage->rActDraw.right), pPage);
               break;

            //case SB_THUMBTRACK:
            case SB_THUMBPOSITION:
               bRedraw = ScrollImage(0,LOWORD(lParam)-pPage->rActDraw.left, pPage);
               break;

            }

         if (bRedraw)
            {
            UpdateWindow(hWnd);
            }

         break;

      case WM_VSCROLL:
         GetClientRect(hWnd,(LPRECT)&rClient);
         hDC=GetDC(hWnd);
         SetWindowView(hDC, pPage);
         DPtoLP(hDC,(LPPOINT)&rClient,2);
         ReleaseDC(hWnd,hDC);
         nLogCliExt=abs(rClient.bottom-rClient.top);
         bRedraw = FALSE;
   
         switch (wParam)
            {
            case SB_TOP:
               bRedraw = ScrollImage(-pPage->rActDraw.top,0, pPage);
               break;

            case SB_BOTTOM:
               bRedraw = ScrollImage(pPage->rWhole.bottom-pPage->rActDraw.bottom,0, pPage);
               break;

            case SB_LINEUP:
               bRedraw = ScrollImage(-min(nLogCliExt/10+1,pPage->rActDraw.top),0, pPage);
               break;

            case SB_LINEDOWN:
               bRedraw = ScrollImage(min(nLogCliExt/10+1,pPage->rWhole.bottom-pPage->rActDraw.bottom),0, pPage);
               break;

            case SB_PAGEUP:
               bRedraw = ScrollImage(-min(nLogCliExt/2+1,pPage->rActDraw.top),0, pPage);
               break;

            case SB_PAGEDOWN:
               bRedraw = ScrollImage(min(nLogCliExt/2+1,pPage->rWhole.bottom-pPage->rActDraw.bottom),0, pPage);
               break;

            //case SB_THUMBTRACK:
            case SB_THUMBPOSITION:
               bRedraw = ScrollImage(LOWORD(lParam)-pPage->rActDraw.top,0, pPage);
               break;
            }

         if (bRedraw)
            {
            UpdateWindow(hWnd);
            }
         break;

      // Keyboard interface for scrolling.
      case WM_KEYDOWN:
         for(i = 0; i < NUMKEYS ; i++)
            {
            if(wParam == KeyScroll[i].wVirtKey)
               {
               SendMessage(hWnd,KeyScroll[i].iMessage,KeyScroll[i].wRequest,0L);
               break;
               }
            }
         break;

      case WM_ERASEBKGND:
         // WM_PAINT will erase the background, so here we simply
         // return FALSE signaling that the background hasn't been 
         // erased yet.
         break;


      case WM_MDIACTIVATE:
         // the following technick is devised to simplify implementation 
         // of MDI from single image display.
         if (wParam) {    /* being activated */
            // the very first time it is NULL and would destroy gPage
            if (pPage->hCurrentBitmap!=NULL)
               gPage = *pPage;
         }
         else {  /* being deactivated */
            memset(&gPage, 0, sizeof gPage);
         }
         break;

      case WM_PAINT:
         PaintBitmap(hWnd, pPage);
         break;

      case WM_SIZE:
         if (pPage->hCurrentBitmap!=NULL)
            {
            if(pPage->nDispFormat == DISP_PREVIEW)
               {
               CalcWindowView(pPage);
               }
            else
               {
               hDC = GetDC(hWnd);
               SetWindowView(hDC, pPage);
               GetClientRect(hWnd,(LPRECT)&rClient);
               DPtoLP(hDC,(LPPOINT)&rClient,2);
   
               pPage->rActDraw.right = pPage->rActDraw.left + (rClient.right-rClient.left);
               pPage->rActDraw.bottom = pPage->rActDraw.top + (rClient.bottom-rClient.top);
               if(AdjustArea(pPage))   InvalidateRect(hWnd,NULL,FALSE);

               ReleaseDC(hWnd,hDC);
               SetScrollBars(pPage);
               }
            }
         bDefProc = TRUE;
         break;

      case PM_IMGINIT:
           *pPage =*(GPAGETYPE *)lParam;

           UpdateBitmap(pPage);
         break;

      case PM_DECOPM_END:
           return pPage->dDecomp.wLinesDecomp;
         break;

      case WM_QUERYENDSESSION:
         // Here it is necessary to ask the user for saving unsaved bitmap.
         if (AskForSave(pPage) == IDCANCEL)
            return(FALSE);                    // Aborts quit.
         else {
            // delete old bitmap
            DeleteBitmap(TRUE, pPage);
      
            return(TRUE);                    // Quits.
         }

      case WM_CREATE:

         //---- Setup images's property
         hMem = LocalAlloc(LHND, sizeof(GPAGETYPE));
         if (hMem == NULL) {
            return TRUE;
         }

         if (SetProp(hWnd, szImgPropName, hMem)) {
            if (!(pPage = (GPAGETYPE *) LocalLock(hMem))) {
               RemoveProp(hWnd, szImgPropName);
               LocalFree(hMem);
               return TRUE;
            }
         }
         else {
            LocalFree(hMem);
            return TRUE;
         }

      break;

      default:           // Passes it on if unproccessed.
         bDefProc = TRUE;
      break;

      }      // End of 'message' switch. 

   /* unlock ourselves */
   if (hMem != NULL) 
      LocalUnlock(hMem);

   if (bDefProc)
      return(DefMDIChildProc(hWnd, message, wParam, lParam));
   else
      return(FALSE);
}

/**********************************************************************************
  Function
      PaintBitmap

  Parameters
      hWnd         Window handle.

  Returns
      None.

  Description
      Handles WM_PAINT message. Also erases background intelligently.

  Notes
      None.

  Author
      Hrasko_Gabor,   02/01/91      Initial version.
**********************************************************************************/

VOID PaintBitmap(HWND hWnd, GPAGETYPE far *pPage)
{
   HDC hDC, hSrcDC;
   PAINTSTRUCT ps;
   RECT rImg, rLog;

   hDC = BeginPaint(hWnd,&ps);

   if (pPage->hCurrentBitmap != NULL) 
      {
      SetWindowView(hDC, pPage);
      rImg = (pPage->nDispFormat==DISP_PREVIEW) ? pPage->rWhole : pPage->rActDraw;

      // Calculates which part of the bitmap must to be painted.
      LPtoDP(hDC,(LPPOINT)&rImg,2);
      // The intersection of the update region (ps.rcPaint) and
      // the bitmap (rImg).
      IntersectRect(&rLog,&rImg,&ps.rcPaint);
      DPtoLP(hDC,(LPPOINT)&rLog,2);
      // Will paint one more line and column to avoid unpainted
      // fraction lines and columns in zoom mode.
      if (rLog.right < pPage->rWhole.right)   rLog.right++;
      if (rLog.bottom < pPage->rWhole.bottom)   rLog.bottom++;

#ifdef TIFFPROG
      if (pPage->dDecomp.wLinesDecomp  && (pPage->dDecomp.wLinesDecomp < rLog.bottom)) {
         FARPROC  lpfnLineProc;
         WORD     wRows;
         WORD     wStrip;
         WORD     wBaseStrip;
         TIFFFILE hChain;
         TIFFLINEDATA TiffLineData;
         HCURSOR  hOldCur;

         hChain = OpenTiffFile(pPage->szFileName,T_READ);
         if (hChain != NULL) {                         // Opening OK.

              // Registers the nImage-th image.
              if (GetTiffImage(hChain,pPage->dDecomp.nImage)) { // Registering OK.

               // get the number of rows to decompress
               wRows  = rLog.bottom - pPage->dDecomp.wLinesDecomp;

               // compute strips 
               wStrip = wRows / pPage->dDecomp.dwRowsPerStrip;

               if (wRows % pPage->dDecomp.dwRowsPerStrip) wStrip++;

               wRows = pPage->dDecomp.dwRowsPerStrip * wStrip;

               // Prepares callback function's pocedure instance.
               lpfnLineProc = MakeProcInstance(FlushTiffLine,hInst);

               wBaseStrip = (pPage->dDecomp.wLinesDecomp / pPage->dDecomp.dwRowsPerStrip);

               TiffLineData.hDC          = hDC;
               TiffLineData.hBitmap      = pPage->hCurrentBitmap;
               TiffLineData.hBitmapInfo  = pPage->hBitmapInfo;

               hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));

               // Fills the image in the bitmap.
               if (!DecodeTiffImage(hChain,pPage->dDecomp.nImage,wBaseStrip, wRows,
                                    (LONG)(TIFFLINEDATA far *)&TiffLineData,
                                    lpfnLineProc)) {
                  if (TiffError() == TENDOFDATA) {
                     MessageBox(NULL,
                     (LPSTR)"Image was smaller that was defined.",
                     (LPSTR)"TIFF warning",
                     MB_OK|MB_ICONEXCLAMATION);
                  }
                  GlobalFree(TiffLineData.hBitmapInfo);
                  // reset local structure we do not need this anymore.
                  memset(&pPage->dDecomp, '\0', sizeof pPage->dDecomp);

                  // clear global structure
                  memset(&gPage, '\0', sizeof gPage);
               }

               // Closes TIFF file.
               CloseTiffFile(hChain);

               SetCursor(hOldCur);

               // Set new decompressed height
               pPage->dDecomp.wLinesDecomp = (wBaseStrip * pPage->dDecomp.dwRowsPerStrip) + wRows;

               if (pPage->dDecomp.wLinesDecomp >= pPage->dDecomp.nImgHeight) {
                  GlobalFree(TiffLineData.hBitmapInfo);

                  // decompressed the image
                  memset(&pPage->dDecomp, '\0', sizeof pPage->dDecomp);

                  // clear global structure
                  memset(&gPage, '\0', sizeof gPage);
               }
            }
         }
      }
#endif

      hSrcDC = CreateCompatibleDC(hDC);
      SelectObject(hSrcDC,pPage->hCurrentBitmap);
   
      // Draws the image.
      BitBlt(hDC,
             rLog.left,
             rLog.top,
             rLog.right-rLog.left, 
             rLog.bottom-rLog.top,
             hSrcDC,
             rLog.left,
             rLog.top,
             SRCCOPY
            );

      DeleteDC(hSrcDC);

      // Excludes the painted rectangle from the clipping region.
      ExcludeClipRect(hDC,
                      rLog.left,
                      rLog.top,
                      rLog.right,
                      rLog.bottom);
      }

   // Erases the uncovered parts of the bacground.
   DPtoLP(hDC,(LPPOINT)&ps.rcPaint,2);
   SelectObject(hDC,GetClassWord(hWnd,GCW_HBRBACKGROUND));
   PatBlt(hDC,
          ps.rcPaint.left,
          ps.rcPaint.top,
          ps.rcPaint.right - ps.rcPaint.left + 1,
          ps.rcPaint.bottom - ps.rcPaint.top + 1,
          PATCOPY
         );

   EndPaint(hWnd,&ps);

   return;
}


/*****************************************************************************
 Function
         About

 Parameters
         dialogboxFN parameters

 Returns
         BOOL

 Description
         Processes ABOUT dialogbox

 Notes
         None.

 Author
         Lorincz_Gabor, 07/06/90 10:10
*****************************************************************************/

BOOL FAR PASCAL About(HWND hDlg, unsigned message, 
                                    WORD wParam, LONG lParam)
{
   struct diskfree_t drvinfo;
   unsigned drive;
   char szBuffer[150];

   switch (message)
      {
      case WM_INITDIALOG:
         // get free disk space
         _dos_getdrive( &drive );
         _dos_getdiskfree( drive, &drvinfo );
         sprintf( szBuffer,"%ldK",
                  (long)drvinfo.avail_clusters *
                  drvinfo.sectors_per_cluster *
                  drvinfo.bytes_per_sector/ 1024L
                  );
         SetDlgItemText(hDlg,AB_DSPACE,szBuffer);

         // get free memory
         sprintf( szBuffer,"%ldK",(long)GlobalCompact(0)/1024L);
         SetDlgItemText(hDlg,AB_CMEM,szBuffer);

         return (TRUE);

      case WM_COMMAND:
         if (wParam == IDOK)
            {
            EndDialog(hDlg,TRUE);
            return (TRUE);
            }
         break;
      }

    return (FALSE);   
}

/**********************************************************************************
  Function
      BmInfoDlgFn

  Parameters
      hDlg                  Dialog box handle.

  Returns
      None.

  Description
      Callback function for Dialog box "BmInfo".

  Notes
      None.

  Author
      Hrasko_Gabor,   01/17/91      Initial version.
**********************************************************************************/

int FAR PASCAL BmInfoDlgFn(HWND hDlg, WORD wMsg, WORD wParam, DWORD lParam)
{
   char Buff[10];
   BITMAP Bm;

   switch(wMsg){

      case WM_INITDIALOG: 
         GetObject(gPage.hCurrentBitmap,sizeof(BITMAP),(LPSTR)&Bm);
         
         if(gPage.szFileName[0] != '\0')
            SetDlgItemText(hDlg,ID_BMNAME,gPage.szFileName);
            
         SetDlgItemText(hDlg,ID_BMWIDTH,itoa(Bm.bmWidth,Buff,10));
         SetDlgItemText(hDlg,ID_BMHEIGHT,itoa(Bm.bmHeight,Buff,10));
         SetDlgItemText(hDlg,ID_BMPLANES,itoa(Bm.bmPlanes,Buff,10));
         SetDlgItemText(hDlg,ID_BMBITS,itoa(Bm.bmBitsPixel,Buff,10));

         return(FALSE);

      case WM_COMMAND:
         switch(wParam){
            case IDOK:
               EndDialog(hDlg,TRUE);
               break;

            default: 
               return(FALSE);
         } 

      default: 
         return(FALSE);
   }
   return(TRUE);
}



/**********************************************************************************
  Function
      SetScrollBars

  Parameters
      hWnd            Window handle.

  Returns
      None.

  Description
      Sets or deletes the scrollbars based on clipping data in pPage->

  Notes
      None.

  Author
      Hrasko_Gabor,   01/16/91      Initial version.
**********************************************************************************/

VOID SetScrollBars(GPAGETYPE far *pPage)
{
   HDC hDC;
   RECT r;
   int nImgX, nImgY, nCliX, nCliY, nActX, nActY;

   if((pPage->hCurrentBitmap == NULL) || (pPage->nDispFormat==DISP_PREVIEW))
      {
       SetScrollRange(pPage->hWndDraw,SB_VERT,0, 0,FALSE);
       SetScrollPos(pPage->hWndDraw,SB_VERT,0,FALSE);
       SetScrollRange(pPage->hWndDraw,SB_HORZ,0, 0,FALSE);
       SetScrollPos(pPage->hWndDraw,SB_HORZ,0,FALSE);
      return;
      }

   GetBitmapDimensions(pPage);
   nImgX = pPage->rWhole.right - pPage->rWhole.left;
   nImgY = pPage->rWhole.bottom - pPage->rWhole.top;
   nActX = pPage->rActDraw.right - pPage->rActDraw.left;
   nActY = pPage->rActDraw.bottom - pPage->rActDraw.top;

   hDC = GetDC(pPage->hWndDraw);
   SetWindowView(hDC, pPage);
   GetClientRect(pPage->hWndDraw,(LPRECT)&r);
   DPtoLP(hDC,(LPPOINT)&r,2);
   ReleaseDC(pPage->hWndDraw,hDC);
   nCliX = r.right - r.left;
   nCliY = r.bottom - r.top;

   // Sets vertical scroll bar.
   if(nImgY < nCliY)       // Client area large enough to receive whole bitmap.
       {
       SetScrollRange(pPage->hWndDraw,SB_VERT,0, 0,FALSE);
       SetScrollPos(pPage->hWndDraw,SB_VERT,0,TRUE);
       }
   else                   // Vertical scrollbar is needed.
      {
      SetScrollRange(pPage->hWndDraw,SB_VERT,0, pPage->rWhole.bottom-nActY,FALSE);
      SetScrollPos(pPage->hWndDraw,SB_VERT,pPage->rActDraw.top,TRUE);
      }

   // Sets horizontal scroll bar.
   if(nImgX < nCliX)       // Client area large enough to receive whole bitmap.
       {
       SetScrollRange(pPage->hWndDraw,SB_HORZ,0, 0,FALSE);
       SetScrollPos(pPage->hWndDraw,SB_HORZ,0,TRUE);
       }
   else                   // Horizontal scrollbar is needed.
      {
      SetScrollRange(pPage->hWndDraw,SB_HORZ,0, pPage->rWhole.right-nActX,FALSE);
      SetScrollPos(pPage->hWndDraw,SB_HORZ,pPage->rActDraw.left,TRUE);
      }

}



/**********************************************************************************
  Function
      SetWindowView

  Parameters
      hWnd              Window handle.
      hDC               DC used in window.

  Returns
      None.

  Description
      Sets mapping mode and refines some values in gPage if necessary.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/30/91      Some simplifications are made.
                                 'Preview' mode is added.
      Lorincz_Gabor,   05/08/90
**********************************************************************************/

void SetWindowView(HDC hDC, GPAGETYPE far *pPage)
{
   SetMapMode(hDC,nMapMode);

   SetWindowExt(hDC,pPage->nWindowXExt,pPage->nWindowYExt);
   if(pPage->nDispFormat==DISP_PREVIEW)      
      SetWindowOrg(hDC,0,0);
   else
      SetWindowOrg(hDC,pPage->rActDraw.left,pPage->rActDraw.top);
   
   SetViewportExt(hDC,pPage->nViewportXExt,pPage->nViewportYExt);
   SetViewportOrg(hDC,0,0);

   SetStretchBltMode(hDC,nStretchBltMode);
}


/**********************************************************************************
  Function
      CalcWindowView

  Parameters
      hWnd               Window handle.

  Returns
      None.

  Description
      Claculates mapping mode based on data in pPage->

  Notes
      None.

  Author
      Hrasko_Gabor,   02/01/91      Initial version.
**********************************************************************************/

VOID CalcWindowView(GPAGETYPE *pPage)
{
  RECT rCli;

  GetClientRect(pPage->hWndDraw,&rCli);

   if(pPage->nDispFormat == DISP_PREVIEW)
      {
      nMapMode             = MM_ISOTROPIC;
      pPage->nWindowXExt   = pPage->rWhole.right-pPage->rWhole.left;
      pPage->nWindowYExt   = pPage->rWhole.bottom-pPage->rWhole.top;
      pPage->nViewportXExt = min(rCli.right,pPage->rWhole.right-pPage->rWhole.left);
      pPage->nViewportYExt = min(rCli.bottom,pPage->rWhole.bottom-pPage->rWhole.top);
      }

   else if (pPage->nDispFormat == DISP_ZOOMED)
      {
      nMapMode             = MM_ISOTROPIC;
      pPage->nWindowXExt   = pPage->rActDraw.right-pPage->rActDraw.left;
      pPage->nWindowYExt   = pPage->rActDraw.bottom-pPage->rActDraw.top;
      pPage->nViewportXExt = rCli.right;
      pPage->nViewportYExt = rCli.bottom;
      }

   else             // no zoom.
      {
      nMapMode             = MM_TEXT;
      pPage->nWindowXExt   = rCli.right;
      pPage->nWindowYExt   = rCli.bottom;
      pPage->nViewportXExt = rCli.right;
      pPage->nViewportYExt = rCli.bottom;
      }

   SetScrollBars(pPage);

}

                
/**********************************************************************************
  Function
      ScrollImage

  Parameters
      hWnd                  Window handle.
      nVert                  Number of logical units to scroll vertically.
      nHoriz               Number of logical units to scroll horizontally.

  Returns
      TRUE if refresh is needed, FALSE otherwise.

  Description
      Modifies the pPage->rActDraw structure to signal a scroll.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/15/91      Initial version.
**********************************************************************************/

BOOL ScrollImage(int nVert, int nHoriz, GPAGETYPE far *pPage)
{
   BOOL bRetVal;
   POINT ptUL;
   HDC hDC;

   bRetVal = (nVert!=0) || (nHoriz!=0);

   if(bRetVal)
      {
      // Calculates the scroll parameters (pixels, not logical units).
      hDC = GetDC(pPage->hWndDraw);
      SetWindowView(hDC, pPage);

      ptUL.x = pPage->rActDraw.left + nHoriz;
      ptUL.y = pPage->rActDraw.top + nVert;
      LPtoDP(hDC,&ptUL,1);
      ReleaseDC(pPage->hWndDraw, hDC);
      ScrollWindow(pPage->hWndDraw,-ptUL.x,-ptUL.y,NULL,NULL);

      // Modifies the display area of the bitmap.
      OffsetRect(&pPage->rActDraw,nHoriz,nVert);

       SetScrollPos(pPage->hWndDraw,SB_VERT,pPage->rActDraw.top,TRUE);
       SetScrollPos(pPage->hWndDraw,SB_HORZ,pPage->rActDraw.left,TRUE);
      }

   return(bRetVal);
}


/**********************************************************************************
  Function
      AdjustArea

  Parameters
      None.

  Returns
      TRUE if area must have been adjusted.

  Description


  Notes
      None.

  Author
      Hrasko_Gabor,   02/01/91      Initial version.
**********************************************************************************/

BOOL AdjustArea(GPAGETYPE far *pPage)
{
   int nWidth, nHeight;
   BOOL bRetVal = FALSE;

   GetBitmapDimensions(pPage);
   nWidth = min(pPage->rActDraw.right-pPage->rActDraw.left,pPage->rWhole.right-pPage->rWhole.left);
   nHeight = min(pPage->rActDraw.bottom - pPage->rActDraw.top,pPage->rWhole.bottom - pPage->rWhole.top);

   if(pPage->rActDraw.right > pPage->rWhole.right)
      {
      pPage->rActDraw.right = pPage->rWhole.right;
      pPage->rActDraw.left = pPage->rActDraw.right-nWidth;
      bRetVal = TRUE;
      }
   if(pPage->rActDraw.left < 0)
      {
      pPage->rActDraw.left = 0;
      pPage->rActDraw.right = nWidth-1;
      bRetVal = TRUE;
      }
   if(pPage->rActDraw.bottom > pPage->rWhole.bottom)
      {
      pPage->rActDraw.bottom = pPage->rWhole.bottom;
      pPage->rActDraw.top = pPage->rActDraw.bottom-nHeight;
      bRetVal = TRUE;
      }
   if(pPage->rActDraw.top < 0)
      {
      pPage->rActDraw.top = 0;
      pPage->rActDraw.bottom = nHeight-1;
      bRetVal = TRUE;
      }

   return(bRetVal);
}


/**********************************************************************************
  Function
      GetBitmapDimensions

  Parameters
      None.

  Returns
      None.

  Description
      Stores the dimensions of the actual bitmap in the rWhole field of pPage->
      Must call if the dimensions has changed.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/16/91      Initial version.
**********************************************************************************/

VOID GetBitmapDimensions(GPAGETYPE far *pPage)
{
   BITMAP bm;

   if(pPage->hCurrentBitmap != NULL)
      {
      GetObject(pPage->hCurrentBitmap,sizeof(BITMAP),(LPSTR)&bm);
      pPage->rWhole.top    = pPage->rWhole.left=0;
      pPage->rWhole.bottom = bm.bmHeight;
      pPage->rWhole.right  = bm.bmWidth;
      }

}




/**********************************************************************************
  Function
      UpdateBitmap

  Parameters
      hWnd               Window handle.

  Returns
      None.

  Description
      Updates the pPage->rActDraw structure and forces a repaint. Only for
      use when bitmap dimensions, or name has changed. Forces to switch
      to 'unzoomed' mode.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/25/91      Initial version.
**********************************************************************************/

VOID UpdateBitmap(GPAGETYPE far *pPage)
{
RECT rClient;

   if(pPage->hCurrentBitmap != NULL)
      {
      GetClientRect(pPage->hWndDraw,(LPRECT)&rClient);
      GetBitmapDimensions(pPage);
      pPage->rActDraw.left   = pPage->rActDraw.top = 0;
      pPage->rActDraw.right  = min(pPage->rWhole.right,rClient.right);
      pPage->rActDraw.bottom = min(pPage->rWhole.bottom,rClient.bottom);
      }

   SetBanner(pPage);

   if (pPage->nDispFormat == DISP_ZOOMED)
       pPage->nDispFormat =  DISP_NORMAL;

   CalcWindowView(pPage);

   InvalidateRect(pPage->hWndDraw,NULL,TRUE);
   UpdateWindow(pPage->hWndDraw);
}

/**********************************************************************************
  Function
      DeleteBitmap

  Parameters
      bDelName                  TRUE if neccessary to delete the file name
                              associated with the bitmap too.

  Returns
      None.

  Description
      Deletes the current bitmap.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/28/91      Initial version.
**********************************************************************************/

VOID DeleteBitmap(BOOL bDelName, GPAGETYPE far *pPage)
{
   if(pPage->hCurrentBitmap != NULL)
      {
      DeleteObject(pPage->hCurrentBitmap);
      pPage->hCurrentBitmap = NULL;
      }

   if(bDelName)   *pPage->szFileName = '\0';
   pPage->bNeedSave = FALSE;
}


/**********************************************************************************
  Function
      ReplaceBitmap

  Parameters
      hWnd                     Window handle.
      hNewBitmap               New bitmap.
      bDelName                  TRUE if neccessary to delete the file name
                              associated with the bitmap too.
      bUpdate                  TRUE if neccessary to update the client area.

  Returns
      None.

  Description
      Replaces the bitmap in pPage->hCurrentBitmap with hNewBitmap.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/25/91      Initial version.
**********************************************************************************/

VOID ReplaceBitmap(HBITMAP hNewBitmap, BOOL bDelName, BOOL bUpdate, GPAGETYPE *pPage)
{
   
   if (pPage->hBitmapInfo)
      GlobalFree(pPage->hBitmapInfo);

   DeleteBitmap(bDelName, pPage);
   pPage->hCurrentBitmap = hNewBitmap;
   if(bUpdate)   UpdateBitmap(pPage);
}

/**********************************************************************************
  Function
      AskForSave

  Parameters
      hWnd               Parent window handle.

  Returns
      IDOK, IDNO or IDCANCEL. In case of IDCANCEL the operation must be
      aborted.

  Description
      Asks wether to save a modified image, or not.

  Notes
      None.

  Author
      Hrasko_Gabor,   01/27/91      Initial version.
**********************************************************************************/

int AskForSave(GPAGETYPE far *pPage)
{
   char szBuffer[150];
   int nAnswer = IDNO;

   if (pPage->bNeedSave)
      {
      sprintf(szBuffer,"Save '%s' before operation ?",
              (*pPage->szFileName) ? pPage->szFileName : "Noname");
      nAnswer = MessageBox(pPage->hWndDraw,(LPSTR)szBuffer,(LPSTR)"Modification check",MB_YESNOCANCEL);
      if (nAnswer == IDYES)
         SaveFunc(pPage); 
      }

   return(nAnswer);
}

/**********************************************************************************
  Function
      InitMenu

  Parameters
      hWnd               Window handle.
                     

  Returns
      None.

  Description
      Initializes the menu according to the actual   conditions.

  Notes
      None.

  Author
      Hrasko_Gabor,   02/01/91      Initial version.
**********************************************************************************/

VOID InitMenu(HWND hWnd)
{
   HANDLE hMenu;

   hMenu=GetMenu(hWndFrame);

   if (gPage.hCurrentBitmap!=NULL)
      {
      EnableMenuItem(hMenu,IDM_CUT,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_COPY,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_DELETE,MF_ENABLED);

      EnableMenuItem(hMenu,IDM_SAVE,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_SAVEAS,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_INVERT,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_ZOOMIN,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_ROTATE_90,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_ROTATE_180,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_FLIP_VERT,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_FLIP_HORIZ,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_DIMENSIONS,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_EXT_GRAB,MF_ENABLED);
      EnableMenuItem(hMenu,IDM_GRAB    ,MF_ENABLED);
      }

   else
      {
      EnableMenuItem(hMenu,IDM_CUT,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_COPY,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_DELETE,MF_GRAYED);

      EnableMenuItem(hMenu,IDM_SAVE,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_SAVEAS,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_INVERT,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_ZOOMIN,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_ROTATE_90,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_ROTATE_180,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_FLIP_VERT,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_FLIP_HORIZ,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_DIMENSIONS,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_EXT_GRAB,MF_GRAYED);
      EnableMenuItem(hMenu,IDM_GRAB    ,MF_GRAYED);
      }

   if (
      IsClipboardFormatAvailable(CF_BITMAP) ||
      IsClipboardFormatAvailable(CF_TEXT)     
      //IsClipboardFormatAvailable(CF_METAFILEPICT)
      )
      {
      EnableMenuItem(hMenu,IDM_PASTE,MF_ENABLED);
      }

   else
      {
      EnableMenuItem(hMenu,IDM_PASTE,MF_GRAYED);
      }

}

//------------------------------------------------------------------
VOID MakeMDIClient(HWND hWnd)
{
CLIENTCREATESTRUCT ccs;

    memset(&ccs, 0, sizeof(CLIENTCREATESTRUCT));

   /* Find window menu where children will be listed */
   ccs.hWindowMenu  = GetSubMenu(GetMenu(hWnd), WINDOWMENU);
   ccs.idFirstChild = IDM_MDICHILD;

   /* Create the MDI client filling the client area */
   hWndMDIClient = CreateWindow(   "mdiclient",
                                 NULL,
                                 WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
                                 0,
                                 0,
                                 0,
                                 0,
                                 hWnd,
                                 NULL,
                                 hInst,
                                 (LPSTR)&ccs
                              );
}

//-----------------------------------------------------------------------
HWND MakeMDIChild(
                     LPSTR szClassName,
                     LPSTR szTitle,
                     DWORD dwStyle, 
                     short x,
                     short y,
                     short nWidth,
                     short nHeight,
                     LONG lParam)
{
   MDICREATESTRUCT   mcs;
   HWND               hChild = NULL;

   ShowStatus(hWndStatus, -1, ST_COFFEE);
   if (!IsEnoughResources())
   {
      ShowStatus(hWndStatus, IDS_READY, ST_READY);
      return NULL;
   }

   mcs.szClass = szClassName;
   mcs.szTitle = szTitle;
   mcs.hOwner   = hInst;
   mcs.x = x;
   mcs.y = y;
   mcs.cx = nWidth;
   mcs.cy = nHeight;
   mcs.style = dwStyle;
   mcs.lParam = lParam;

   hChild = (HWND)SendMessage
   (
      hWndMDIClient,
      WM_MDICREATE,
      0, (LONG)(LPMDICREATESTRUCT)&mcs
   );

   ShowStatus(hWndStatus, IDS_READY, ST_READY);

   return hChild;
}

//------------------------------------------------------------------
VOID MakeStatusBar(HWND hWnd)
{
char  szTemp[32];
char  szReady[32];
RECT  rc;

   memset(szTemp, 0, 32);
   memset(szReady, 0, 32);
   memset(&rc, 0, sizeof(RECT));

   if (!LoadString(hInst, IDS_STATUSCLASS, szTemp, 31))
   {
      ErrorMessage(hWnd, hInst, IDS_LOWMEMORY);
      return;
   }

   GetClientRect(hWnd, &rc);
   rc.top = rc.bottom - yChar * 3 / 2;

   LoadString(hInst, IDS_READY, szReady, 31);
   hWndStatus = CreateWindow(   szTemp,
                              szReady,
                              WS_DLGFRAME | WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, 
                              0,               
                              0,               
                              0,               
                              0,               
                              hWnd,               //parent
                              ID_STATUS,
                              hInst,                   
                              NULL                         
                           );
   if (!hWndStatus)
       ErrorMessage(hWnd, hInst, IDS_LOWMEMORY);
}

//-----------------------------------------------------------------------
VOID MenuMessage(unsigned message, WORD wParam, LONG lParam)
{

   if (wParam >= IDM_OPEN && wParam <= IDM_DECOMP) {
      ShowStatus(hWndStatus, wParam, ST_MENU);
   }
   else {
      if (LOWORD(lParam) == -1)
         ShowStatus(hWndStatus, IDS_READY, ST_REGULAR);
   }
}

//----------------------------------------------------------------
VOID CloseAllChildren ( VOID )
{
   HWND hWndT = NULL;

   /* hide the MDI client window to avoid multiple repaints */
   ShowWindow(hWndMDIClient, SW_HIDE);

   /* As long as the MDI client has a child, destroy it */
   while ( hWndT = GetWindow (hWndMDIClient, GW_CHILD))
   {
      /* Skip the icon title windows */
      while (hWndT && GetWindow (hWndT, GW_OWNER))
         hWndT = GetWindow (hWndT, GW_HWNDNEXT);

      if (!hWndT)
         break;

      SendMessage(hWndMDIClient, WM_MDIDESTROY, (WORD)hWndT, 0L);
   }

   ShowWindow( hWndMDIClient, SW_SHOW);
}

//-----------------------------------------------------------------------
BOOL IsEnoughResources()
{
   DWORD            dwSegment;
   int               iPercent;

   LocalShrink(hUserLib, 1024);

   dwSegment = GlobalSize(hUserLib);
   iPercent = (int)(dwSegment/655);

   if (iPercent < 85)
      return TRUE;
   else if (iPercent >= 85 && iPercent <= 92 )
   {
      char szTemp[128], szAppName[64];

      memset(szTemp, 0, 128);
      memset(szAppName, 0, 64);
      LoadString(hInst, IDS_APPNAME, (LPSTR)szAppName, 63);
       LoadString(hInst, IDS_RESOURCESGETTINGLOW, (LPSTR)szTemp, 127);
      MessageBox(hWndMDIClient, (LPSTR)szTemp, (LPSTR)szAppName, MB_OK|MB_ICONHAND);
      return TRUE;
   }
   else
   {
      ErrorMessage(hWndMDIClient, hInst, IDS_RESOURCESGONE);
      return FALSE;
   }
}

//--------------------------------- Footnotes ---------------------------------

//-------------------------------- End of file --------------------------------

